@ echo off
rem ====	Download Firefox Setup 110.0.1.exe	2023-03-11

rem ====

set F_Url=https://ftp.mozilla.org/pub/firefox/releases/110.0.1/win64/zh-TW/Firefox Setup 110.0.1.exe
set F_Name=Firefox Setup 110.0.1.exe

set F_Path=%USERPROFILE%\Downloads\
set T_Path=%USERPROFILE%\Downloads\

call :DelFile "%F_Path%%F_Name%"
call :RunCurl "%F_Url%" "%F_Name%" "%T_Path%"

call :CheckDir "%T_Path%"
rem call :Runtar "%F_Path%%F_Name%" "%T_Path%"

call :RunExplorer "%T_Path%"

goto end

:DelFile
	if not exist "%~1" (
		echo %~1 not found
		exit /b
	)
	if exist "%~1" (
		del /Q /F "%~1"
	)
	if not exist "%~1" (
		echo %~1 Deleted
		exit /b
	)
	exit /b

:CheckDir
	if exist "%~1" (
		exit /b
	)
	if not exist "%~1" (
		mkdir "%~1"
	)
	if exist "%~1" (
		echo %~1 Created
		exit /b
	)
	exit /b

:RunCurl
	echo "%~1"
	echo Download to %~3
	set para1="%~1"
	set para2="%~2"
	setlocal enabledelayedexpansion
	set U_para1=!para1: =%%20!
 	set F_para2=!para2: =%%20!

	curl.exe --url "%U_para1%" --output "%F_para2%"
	move  /Y "%F_para2%" "%~3%~2"
	exit /b

:Runtar
	echo Extract zip File to %~2
	cd "%~2"
	tar zxvf "%~1"

	exit /b

:RunExplorer
	call Explorer.exe /root,%~1
	goto End

:End
	%SystemRoot%\system32\cmd /k
